From af315ad0b41fe297aa98e2918e9e7aae9048cf2e Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Jan 18 2018 16:36:31 +0000
Subject: [PATCH 37/48] migrate ModuleComponent* to TreeObj


---

diff --git a/modulemd/components/__init__.py b/modulemd/components/__init__.py
index 027c73e..52c812a 100644
--- a/modulemd/components/__init__.py
+++ b/modulemd/components/__init__.py
@@ -24,6 +24,8 @@
 
 from gi.repository import Modulemd
 
+from ..legacy_wrappers import TreeObj
+
 from .module import ModuleComponentModule
 from .rpm import ModuleComponentRPM
 
@@ -31,14 +33,17 @@ from .rpm import ModuleComponentRPM
 supported_content = ("rpms", "modules",)
 
 
-class ModuleComponents(object):
+class ModuleComponents(TreeObj):
     """Class representing components of a module."""
 
+    tree_props = ('rpms', 'modules')
+    tree_identity = 'components'
+
     def __init__(self, parent=None):
         """Creates a new ModuleComponents instance."""
-        self.parent = parent
-        self._rpms = {}
-        self._modules = {}
+        super(ModuleComponents, self).__init__(parent=parent)
+        self.rpms = {}
+        self.modules = {}
 
     def __repr__(self):
         return "<ModuleComponents: modules: {!r}, rpms: {!r}>".format(
@@ -97,7 +102,11 @@ class ModuleComponents(object):
         """A dictionary of RPM components in this module.  The keys are SRPM
         names, the values ModuleComponentRPM instances.
         """
-        return self._rpms
+        if self.parent:
+            return {k: ModuleComponentRPM._new_from_native(v, parent=self.parent)
+                    for k, v in self.parent.module.get_rpm_components().items()}
+        else:
+            return self._rpms
 
     @rpms.setter
     def rpms(self, d):
@@ -109,47 +118,62 @@ class ModuleComponents(object):
                                        Modulemd.ComponentRpm))):
                 raise TypeError("components.rpms: data type not supported"
                                 " ({!r}: {!r})".format(k, v))
-            if isinstance(v, Modulemd.ComponentRpm):
-                d[k] = ModuleComponentRPM._new_from_native(k, v)
-        self._rpms = d
+            if not self.parent and isinstance(v, Modulemd.ComponentRpm):
+                d[k] = ModuleComponentRPM._new_from_native(v)
+            elif self.parent and isinstance(v, ModuleComponentRPM):
+                d[k] = v._to_native()
 
-        self._save_to_libmodulemd()
+        if self.parent:
+            self.parent.module.set_rpm_components(d)
+        else:
+            self._rpms = d
 
     def add_rpm(self, name, rationale, buildorder=0,
             repository="", ref="", cache="", arches=set(), multilib=set()):
         """Adds an RPM to the set of module components."""
-        component = ModuleComponentRPM(name, rationale)
-        component.buildorder = buildorder
-        component.repository = repository
-        component.ref = ref
-        component.cache = cache
-        component.arches = arches
-        component.multilib = multilib
-        self._rpms[name] = component
-
-        self._save_to_libmodulemd()
+        component = ModuleComponentRPM(name=name, rationale=rationale,
+                                       buildorder=buildorder,
+                                       repository=repository, ref=ref,
+                                       cache=cache, arches=arches,
+                                       multilib=multilib,
+                                       parent=self.parent)
+
+        if self.parent:
+            rpms = self.rpms
+            rpms[name] = component
+            self.rpms = rpms
+        else:
+            self._rpms[name] = component
 
     def del_rpm(self, s):
         """Removes the supplied RPM from the set of module components."""
         if not isinstance(s, str):
             raise TypeError("components.del_rpm: data type not supported")
-        if s in self._rpms:
-            del self._rpms[s]
-
-        self._save_to_libmodulemd()
+        if self.parent:
+            rpms = self.rpms
+            rpms.pop(s, None)
+            self.rpms = rpms
+        else:
+            try:
+                del self._rpms[s]
+            except KeyError:
+                pass
 
     def clear_rpms(self):
         """Clear the RPM component dictionary."""
-        self._rpms.clear()
-
-        self._save_to_libmodulemd()
+        self.rpms = {}
 
     @property
     def modules(self):
         """A dictionary of module-type components in this module.  The keys are
         module names, the values ModuleComponentModule instances.
         """
-        return self._modules
+        if self.parent:
+            return {k: ModuleComponentModule._new_from_native(v, parent=self.parent)
+                    for k, v in
+                    self.parent.module.get_module_components().items()}
+        else:
+            return self._modules
 
     @modules.setter
     def modules(self, d):
@@ -161,33 +185,43 @@ class ModuleComponents(object):
                                        Modulemd.ComponentModule))):
                 raise TypeError("components.modules: data type not supported"
                                 " ({!r}: {!r})".format(k, v))
-            if isinstance(v, Modulemd.ComponentModule):
+            if not self.parent and isinstance(v, Modulemd.ComponentModule):
                 d[k] = ModuleComponentModule._new_from_native(k, v)
-        self._modules = d
+            elif self.parent and isinstance(v, ModuleComponentModule):
+                d[k] = v._to_native()
 
-        self._save_to_libmodulemd()
+        if self.parent:
+            self.parent.module.set_module_components(d)
+        else:
+            self._modules = d
 
     def add_module(self, name, rationale, buildorder=0,
             repository="", ref=""):
-        component = ModuleComponentModule(name, rationale)
-        component.buildorder = buildorder
-        component.repository = repository
-        component.ref = ref
-        self._modules[name] = component
+        component = ModuleComponentModule(name=name, rationale=rationale,
+                                          buildorder=buildorder,
+                                          repository=repository, ref=ref)
 
-        self._save_to_libmodulemd()
+        if self.parent:
+            modules = self.modules
+            modules[name] = component
+            self.modules = modules
+        else:
+            self._modules[name] = component
 
     def del_module(self, s):
         """Removes the supplied module from the set of module components."""
         if not isinstance(s, str):
             raise TypeError("components.del_module: data type not supported")
-        if s in self._modules:
-            del self._modules[s]
-
-        self._save_to_libmodulemd()
+        if self.parent:
+            modules = self.modules
+            modules.pop(s, None)
+            self.modules = modules
+        else:
+            try:
+                del self._modules[s]
+            except KeyError:
+                pass
 
     def clear_modules(self):
         """Clear the module-type component dictionary."""
-        self._modules.clear()
-
-        self._save_to_libmodulemd()
+        self.modules = {}
diff --git a/modulemd/components/base.py b/modulemd/components/base.py
index 96da94d..bf02033 100644
--- a/modulemd/components/base.py
+++ b/modulemd/components/base.py
@@ -24,17 +24,28 @@
 
 import sys
 
+from ..legacy_wrappers import TreeObj
+
+
 if sys.version_info > (3,):
     integer_types = (int,)
 else:
     integer_types = (int, long)
 
 
-class ModuleComponentBase(object):
+class ModuleComponentBase(TreeObj):
     """A base class for definining module component types."""
 
-    def __init__(self, name, rationale, buildorder=0):
+    tree_props = ('name', 'rationale', 'buildorder')
+
+    # set this to a child class of Modulemd.Component
+    component_class = None
+
+    def __init__(self, name, rationale, buildorder=0, parent=None):
         """Creates a new ModuleComponentBase instance."""
+        super(ModuleComponentBase, self).__init__(parent=parent)
+        if parent:
+            self.component = self.component_class()
         self.name = name
         self.rationale = rationale
         self.buildorder = buildorder
@@ -60,36 +71,56 @@ class ModuleComponentBase(object):
     @property
     def name(self):
         """A string property representing the component name."""
-        return self._name
+        if self.parent:
+            return self.component.get_name()
+        else:
+            return self._name
 
     @name.setter
     def name(self, s):
         if not isinstance(s, str):
             raise TypeError("componentbase.name: data type not supported")
-        self._name = s
+
+        if self.parent:
+            self.component.set_name(s)
+        else:
+            self._name = s
 
     @property
     def rationale(self):
         """A string property representing the rationale for the component
         inclusion in the module.
         """
-        return self._rationale
+        if self.parent:
+            return self.component.get_rationale()
+        else:
+            return self._rationale
 
     @rationale.setter
     def rationale(self, s):
         if not isinstance(s, str):
-            raise TypeError("componentbase.rationale: data type not supported")
-        self._rationale = s
+            raise TypeError("componentbase.rationale: data type not supported"
+                            " ({!r})".format(s))
+        if self.parent:
+            self.component.set_rationale(s)
+        else:
+            self._rationale = s
 
     @property
     def buildorder(self):
         """An integer property representing the buildorder index for this
         component.
         """
-        return self._buildorder
+        if self.parent:
+            return self.component.get_buildorder()
+        else:
+            return self._buildorder
 
     @buildorder.setter
     def buildorder(self, i):
         if not isinstance(i, integer_types):
             raise TypeError("componentbase.buildorder: data type not supported")
-        self._buildorder = i
+        if self.parent:
+            self.component.set_buildorder(i)
+        else:
+            self._buildorder = i
diff --git a/modulemd/components/module.py b/modulemd/components/module.py
index 31dbfc7..3052652 100644
--- a/modulemd/components/module.py
+++ b/modulemd/components/module.py
@@ -22,25 +22,44 @@
 #
 # Written by Petr Šabata <contyk@redhat.com>
 
+from gi.repository import Modulemd
+
 from .base import ModuleComponentBase
 
 
 class ModuleComponentModule(ModuleComponentBase):
     """A component class for handling module-type content."""
 
+    tree_props = ('repository', 'ref')
+
+    component_class = Modulemd.ComponentModule
+
     def __init__(self, name, rationale, buildorder=0,
-                 repository="", ref=""):
+                 repository="", ref="", parent=None):
         """Creates a new ModuleComponentModule instance."""
-        super(ModuleComponentModule, self).__init__(name, rationale, buildorder)
+        super(ModuleComponentModule, self).__init__(name=name,
+                                                    rationale=rationale,
+                                                    buildorder=buildorder,
+                                                    parent=parent)
         self.repository = repository
         self.ref = ref
 
     @classmethod
-    def _new_from_native(cls, name, native_comp):
-        return cls(name, native_comp.get_rationale(),
+    def _new_from_native(cls, native_comp, parent=None):
+        return cls(native_comp.get_name(), native_comp.get_rationale(),
                    buildorder=native_comp.get_buildorder() or 0,
                    repository=native_comp.get_repository() or "",
-                   ref=native_comp.get_ref() or "")
+                   ref=native_comp.get_ref() or "",
+                   parent=parent)
+
+    def _to_native(self):
+        obj = self.component_class()
+        obj.set_name(self.name)
+        obj.set_rationale(self.rationale)
+        obj.set_buildorder(self.buildorder)
+        obj.set_repository(self.repository or None)
+        obj.set_ref(self.ref or None)
+        return obj
 
     def __repr__(self):
         return ("<ModuleComponentModule: name: {!r}, rationale: {!r},"
@@ -49,8 +68,8 @@ class ModuleComponentModule(ModuleComponentBase):
                     self.repository, self.ref)
 
     def __bool__(self):
-        return True if (self.name or self.rationale or self.buildorder or
-                self.repository or self.ref) else False
+        return True if (super(ModuleComponentModule, self).__bool()
+                        or self.repository or self.ref) else False
 
     __nonzero__ = __bool__
 
@@ -66,23 +85,37 @@ class ModuleComponentModule(ModuleComponentBase):
         """A string property representing the VCS repository with the modulemd
         file and possibly other module data.
         """
-        return self._repository
+        if self.parent:
+            return self.component.get_repository()
+        else:
+            return self._repository
 
     @repository.setter
     def repository(self, s):
         if not isinstance(s, str):
             raise TypeError("componentmodule.repository: data type not supported")
-        self._repository = s
+
+        if self.parent:
+            self.component.set_repository(s)
+        else:
+            self._repository = s
 
     @property
     def ref(self):
         """A string property representing the particular repository commit
         hash, branch or tag name used in this module.
         """
-        return self._ref
+        if self.parent:
+            return self.component.get_ref()
+        else:
+            return self._ref
 
     @ref.setter
     def ref(self, s):
         if not isinstance(s, str):
             raise TypeError("componentmodule.ref: data type not supported")
-        self._ref = s
+
+        if self.parent:
+            self.component.set_ref(s)
+        else:
+            self._ref = s
diff --git a/modulemd/components/rpm.py b/modulemd/components/rpm.py
index 9a6e47b..d7f616e 100644
--- a/modulemd/components/rpm.py
+++ b/modulemd/components/rpm.py
@@ -22,17 +22,26 @@
 #
 # Written by Petr Šabata <contyk@redhat.com>
 
+from gi.repository import Modulemd
+
 from .base import ModuleComponentBase
 
 
 class ModuleComponentRPM(ModuleComponentBase):
     """A component class for handling RPM content."""
 
+    tree_props = ('repository', 'ref', 'cache', 'arches', 'multilib')
+
+    component_class = Modulemd.ComponentRpm
+
     def __init__(self, name, rationale, buildorder=0,
                  repository="", ref="", cache="", arches=set(),
-                 multilib=set()):
+                 multilib=set(), parent=None):
         """Creates a new ModuleComponentRPM instance."""
-        super(ModuleComponentRPM, self).__init__(name, rationale, buildorder)
+        super(ModuleComponentRPM, self).__init__(name=name,
+                                                 rationale=rationale,
+                                                 buildorder=buildorder,
+                                                 parent=parent)
         self.repository = repository
         self.ref = ref
         self.cache = cache
@@ -40,14 +49,35 @@ class ModuleComponentRPM(ModuleComponentBase):
         self.multilib = multilib
 
     @classmethod
-    def _new_from_native(cls, name, native_comp):
-        return cls(name, native_comp.get_rationale(),
+    def _new_from_native(cls, native_comp, parent=None):
+        return cls(name=native_comp.get_name(),
+                   rationale=native_comp.get_rationale(),
                    buildorder=native_comp.get_buildorder() or 0,
                    repository=native_comp.get_repository() or "",
                    ref=native_comp.get_ref() or "",
                    cache=native_comp.get_cache() or "",
                    arches=set(native_comp.get_arches().get()),
-                   multilib=set(native_comp.get_multilib().get()))
+                   multilib=set(native_comp.get_multilib().get()),
+                   parent=parent)
+
+    def _to_native(self):
+        obj = self.component_class()
+        obj.set_name(self.name)
+        obj.set_rationale(self.rationale)
+        obj.set_buildorder(self.buildorder)
+        obj.set_repository(self.repository or None)
+        obj.set_ref(self.ref or None)
+        obj.set_cache(self.cache or None)
+
+        ss = Modulemd.SimpleSet()
+        ss.set(list(self.arches))
+        obj.set_arches(ss)
+
+        ss = Modulemd.SimpleSet()
+        ss.set(list(self.multilib))
+        obj.set_multilib(ss)
+
+        return obj
 
     def __repr__(self):
         return ("<ModuleComponentRPM: name: {!r}, rationale: {!r},"
@@ -58,7 +88,7 @@ class ModuleComponentRPM(ModuleComponentBase):
                     sorted(self.multilib))
 
     def __bool__(self):
-        return True if (self.name or self.rationale or self.buildorder or
+        return True if (super(ModuleComponentRPM, self).__bool__() or
                 self.repository or self.ref or self.cache or self.arches or
                 self.multilib) else False
 
@@ -79,39 +109,59 @@ class ModuleComponentRPM(ModuleComponentBase):
         """A string property representing the VCS repository with the RPM SPEC
         file, patches and other package data.
         """
-        return self._repository
+        if self.parent:
+            return self.component.get_repository()
+        else:
+            return self._repository
 
     @repository.setter
     def repository(self, s):
         if not isinstance(s, str):
-            raise TypeError("componentrpm.repository: data type not supported")
-        self._repository = s
+            raise TypeError("componentrpm.repository: data type not supported"
+                            " ({!r}".format(s))
+
+        if self.parent:
+            self.component.set_repository(s)
+        else:
+            self._repository = s
 
     @property
     def ref(self):
         """A string property representing the particular repository commit
         hash, branch or tag name used in this module.
         """
-        return self._ref
+        if self.parent:
+            return self.component.get_ref()
+        else:
+            return self._ref
 
     @ref.setter
     def ref(self, s):
         if not isinstance(s, str):
             raise TypeError("componentrpm.ref: data type not supported")
-        self._ref = s
+        if self.parent:
+            self.component.set_ref(s)
+        else:
+            self._ref = s
 
     @property
     def cache(self):
         """A string property representing the URL to the lookaside cache where
         this packages' sources are stored.
         """
-        return self._cache
+        if self.parent:
+            return self.component.get_cache()
+        else:
+            return self._cache
 
     @cache.setter
     def cache(self, s):
         if not isinstance(s, str):
             raise TypeError("componentrpm.cache: data type not supported")
-        self._cache = s
+        if self.parent:
+            self.component.set_cache(s)
+        else:
+            self._cache = s
 
     @property
     def arches(self):
@@ -119,7 +169,10 @@ class ModuleComponentRPM(ModuleComponentBase):
         empty set equals to the package being available on all supported
         architectures.
         """
-        return self._arches
+        if self.parent:
+            return set(self.component.get_arches().get())
+        else:
+            return self._arches
 
     @arches.setter
     def arches(self, ss):
@@ -128,7 +181,12 @@ class ModuleComponentRPM(ModuleComponentBase):
         for v in ss:
             if not isinstance(v, str):
                 raise TypeError("componentrpm.arches: data type not supported")
-        self._arches = ss
+        if self.parent:
+            _ss = Modulemd.SimpleSet()
+            _ss.set(list(ss))
+            self.component.set_arches(_ss)
+        else:
+            self._arches = ss
 
     @property
     def multilib(self):
@@ -136,7 +194,10 @@ class ModuleComponentRPM(ModuleComponentBase):
         What this actually means varies from architecture to architecture.  An
         empty set is equal to no multilib.
         """
-        return self._multilib
+        if self.parent:
+            return set(self.component.get_multilib().get())
+        else:
+            return self._multilib
 
     @multilib.setter
     def multilib(self, ss):
@@ -145,4 +206,9 @@ class ModuleComponentRPM(ModuleComponentBase):
         for v in ss:
             if not isinstance(v, str):
                 raise TypeError("componentrpm.multilib: data type not supported")
-        self._multilib = ss
+        if self.parent:
+            _ss = Modulemd.SimpleSet()
+            _ss.set(list(ss))
+            self.component.set_multilib(_ss)
+        else:
+            self._multilib = ss

